media-libs/mesa: Bump to 7.11_rc4, remove hacks needed for rc2
authorRemi Cardona <remi@gentoo.org>
Fri, 29 Jul 2011 22:10:44 +0000 (22:10 +0000)
committerRemi Cardona <remi@gentoo.org>
Fri, 29 Jul 2011 22:10:44 +0000 (22:10 +0000)
Package-Manager: portage-2.2.0_alpha47/cvs/Linux i686

media-libs/mesa/ChangeLog
media-libs/mesa/Manifest
media-libs/mesa/mesa-7.11_rc4.ebuild [new file with mode: 0644]

index 0da0c7f4b68ad42fce90b1ef9cb18b170bf1068b..bcc3123292032a04aa4223d512478dbd525ecb2d 100644 (file)
@@ -1,6 +1,11 @@
 # ChangeLog for media-libs/mesa
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/media-libs/mesa/ChangeLog,v 1.351 2011/07/29 10:41:06 xarthisius Exp $
+# $Header: /var/cvsroot/gentoo-x86/media-libs/mesa/ChangeLog,v 1.352 2011/07/29 22:10:44 remi Exp $
+
+*mesa-7.11_rc4 (29 Jul 2011)
+
+  29 Jul 2011; RĂ©mi Cardona <remi@gentoo.org> +mesa-7.11_rc4.ebuild:
+  Bump to 7.11_rc4, remove hacks needed for rc2
 
   29 Jul 2011; Kacper Kowalik <xarthisius@gentoo.org> mesa-7.10.3.ebuild:
   ppc64 stable wrt #371857
index 7c5c5ad290002e43ae87a87fa8674d8615c98d5c..2f517fc0b39f9927c709829746f0919478daeb19 100644 (file)
@@ -1,5 +1,5 @@
 -----BEGIN PGP SIGNED MESSAGE-----
-Hash: SHA256
+Hash: SHA1
 
 AUX eselect-mesa.conf.7.10 1670 RMD160 a500c3af1c036678a84548b92e348b12a72ec117 SHA1 38cc1b51398382f5a2d1b89da4f16d3fa0e55450 SHA256 3ff15cedc353feeb2da450533c2ea2efc33ed1c8434a7b3037999c4965907149
 AUX eselect-mesa.conf.7.11 1670 RMD160 74d85b0481f36a8e2b2e09245d49d09671500946 SHA1 5c5f468feaae946e5901698d1c0ffe8fc480b783 SHA256 448d08e97e931563aa2e33f22feeaf911caf9a2eb9fd7b446485311d1dcc1225
@@ -8,6 +8,7 @@ AUX glx_ro_text_segm.patch 731 RMD160 6d2bd85591d6349fa45a5ee16c724859c640e902 S
 DIST MesaLib-7.10.2.tar.bz2 5863551 RMD160 4e5cfdf3b66f1b05d1aefd5267fe157e542f6ac2 SHA1 71bbb2686230f6334aa625a951b58b4b2d5d6aa0 SHA256 8ced2678ce11cf30804694a92ea3ca6b82f158ae8995bdc626c7e85aac71c7c1
 DIST MesaLib-7.10.3.tar.bz2 6056837 RMD160 bd9800a0cf98560a4424742cac635b4c07a39647 SHA1 e1fe8bad90bb24cc4b25a42932c277a0e0d7a2ac SHA256 1e701fc839b872677ddca9ed8784d754c9da1fbeda98173980e06aa7df0e85c0
 DIST MesaLib-7.11-rc2.tar.bz2 6296121 RMD160 5adb206406aaec7b8aef90bd3eb4e5740268baa5 SHA1 5ff61ae7a75dd37691915ec1706161d26392ddbb SHA256 c08657a47af6deaf706b6036fc71a5160ca4f718dee35c8ce927b6c7a7964a4c
+DIST MesaLib-7.11-rc4.tar.bz2 6557358 RMD160 830f78b5680c8209040daccbe53f4fba0b34d33d SHA1 951f980af4708eb6b7a43e8bc5f165f3ee7102dc SHA256 9f9113c2a908c572d1e6eda1755969ed3e0cda634b45c05dc6ea02230efc9d4a
 DIST MesaLib-7.9.2.tar.bz2 5648858 RMD160 d6665c1eb1035b9bebc743401355c39aaffcdf5c SHA1 973d27e49654b7bd1ed0d3c4c986d26d25ccabed SHA256 6b54c96ba0673c3f088bf9a56c2d64a6e54831a1065dedf0ac234d7cd5151253
 DIST mesa-7.10.1-gentoo-patches-01.tar.bz2 5488 RMD160 acc52b4f05b82a98e7994dc005699630270de360 SHA1 f38c616eeacbeebe597ed4bc98b84a41caa18108 SHA256 31cd4f6d1a0a70249c40452919074856d120cd473a01a8457e3dc147a1b622d8
 DIST mesa-7.10.2-gentoo-patches-01.tar.bz2 5974 RMD160 aa2ddbd006734b4493fafeb2daeac2c5f36b0469 SHA1 5cfe8ba2e23cc55eea2d8bf44cd6515b5fe453de SHA256 9944599547f9552f5233043a8964708a05608cc2b17127503bf299fede037f80
@@ -15,15 +16,14 @@ EBUILD mesa-7.10.2-r1.ebuild 9742 RMD160 32520243f48c0e40b8668a0f7ec631dacd43114
 EBUILD mesa-7.10.2.ebuild 9768 RMD160 47dd9bb4c2d1dbe37bd1450ebd026ca5f0fa8e79 SHA1 ef337243869cb046a10ffab9c32a18f19becc2e9 SHA256 1f2c3c4e027a30a939d442e1ad8d811869ef1dbabd8cdf0676108ee39f597c4b
 EBUILD mesa-7.10.3.ebuild 9769 RMD160 d3602850a5fbaba33a0f89c63fd152483dc60050 SHA1 546300995576bdb93fc6077009311a89559f3346 SHA256 67c37e7eab531ac317806688646eb98ea184a3ebe20710042a0b2ef080ef446c
 EBUILD mesa-7.11_rc2.ebuild 9953 RMD160 97d5d82a6985b3b0bd6f137ac7c262b0ec086d21 SHA1 29010cbc0b7d6a745b7b994cb48e56c8936f241c SHA256 e941893dd5aed186657731a48ce64046b4ef01941a0116c1c85cd62dc47540c4
+EBUILD mesa-7.11_rc4.ebuild 9752 RMD160 f503c5eba030b8ece6e3366e668912b027f30378 SHA1 0b06e916fa63bd063dfb0fe621d31d088d04215f SHA256 460c30f730cfabbf9769a93e1468d20401b3240cc5ef067c321b324151faf56d
 EBUILD mesa-7.9.2.ebuild 8909 RMD160 b4ff6784c3e54dd76bb6085f0ff110897922c294 SHA1 d0ecb14966b60671f486ea55db9e16a305b7e5da SHA256 5bc74c4a3b3473a48c4985d9b255d3a60a26a939294a06b443bb7caf5423cf40
-MISC ChangeLog 58386 RMD160 80851684d3d604c634b718529624946a6e07818c SHA1 15482d3801eba7e01d7e4f3856e6d619b2936f06 SHA256 346b501c608b1ccb47903e9acaeaa37ab04b79bc5fbcbd2cace05e84f84e0e92
+MISC ChangeLog 58529 RMD160 2fe9b94e0e31b7df0006e5345ed707a6fdfee314 SHA1 7721d724eaed2c040fd5648d5a066e6752d31f42 SHA256 846fc8a85948cb5aeac537db77e378c1c31682b1f2bdae5fb7a0fe28d00f2c0b
 MISC metadata.xml 860 RMD160 d108595ff01a4508486d4ddc6e5875eb2d6f1277 SHA1 a4a5876ef7be72273d7893a8573b12fb39a50426 SHA256 b8a309225d512ad3848d9bea0b6badd447918bde1ef4489c736f12e6c23970ac
 -----BEGIN PGP SIGNATURE-----
 Version: GnuPG v2.0.17 (GNU/Linux)
 
-iJwEAQEIAAYFAk4yjkgACgkQIiMqcbOVdxR2EAQAidEwh/jOnW9cRVuwRf/P95w6
-YRJjERdz4NDCN9Pst2zaVJa4l0nZCE2T9bRQMchwXbJQuAbTAqPq7npsOUgDmcAs
-64zE2y1URyqWXXYl5MjVAqlfewxOiTLtbDbx0ZgGfBiD1qcolWgl34tnug4XBCiM
-n3lAtAvYQspx2xxJfZ4=
-=WpfG
+iEYEARECAAYFAk4zL+AACgkQfUU/I5AasIrYNACfbmC9a/8KnlVaO1n5sGW7NFzR
+KYIAoLP2696HYzd0ir6VQcqdTp9HIPs2
+=pXv7
 -----END PGP SIGNATURE-----
diff --git a/media-libs/mesa/mesa-7.11_rc4.ebuild b/media-libs/mesa/mesa-7.11_rc4.ebuild
new file mode 100644 (file)
index 0000000..0305c74
--- /dev/null
@@ -0,0 +1,364 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/media-libs/mesa/mesa-7.11_rc4.ebuild,v 1.1 2011/07/29 22:10:44 remi Exp $
+
+EAPI=3
+
+EGIT_REPO_URI="git://anongit.freedesktop.org/mesa/mesa"
+
+if [[ ${PV} = 9999* ]]; then
+       GIT_ECLASS="git-2"
+       EXPERIMENTAL="true"
+fi
+
+inherit base autotools multilib flag-o-matic python toolchain-funcs ${GIT_ECLASS}
+
+OPENGL_DIR="xorg-x11"
+
+MY_PN="${PN/m/M}"
+MY_P="${MY_PN}-${PV/_/-}"
+MY_SRC_P="${MY_PN}Lib-${PV/_/-}"
+
+FOLDER="${PV/_rc*/}"
+
+DESCRIPTION="OpenGL-like graphic library for Linux"
+HOMEPAGE="http://mesa3d.sourceforge.net/"
+
+#SRC_PATCHES="mirror://gentoo/${P}-gentoo-patches-01.tar.bz2"
+if [[ $PV = 9999* ]]; then
+       SRC_URI="${SRC_PATCHES}"
+else
+       SRC_URI="ftp://ftp.freedesktop.org/pub/mesa/${FOLDER}/${MY_SRC_P}.tar.bz2
+               ${SRC_PATCHES}"
+fi
+
+LICENSE="LGPL-2 kilgard"
+SLOT="0"
+KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~sh ~sparc ~x86 ~x86-fbsd ~x86-freebsd ~amd64-linux ~ia64-linux ~x86-linux ~sparc-solaris ~x64-solaris ~x86-solaris"
+
+INTEL_CARDS="intel"
+RADEON_CARDS="radeon"
+VIDEO_CARDS="${INTEL_CARDS} ${RADEON_CARDS} mach64 mga nouveau r128 savage sis vmware tdfx via"
+for card in ${VIDEO_CARDS}; do
+       IUSE_VIDEO_CARDS+=" video_cards_${card}"
+done
+
+IUSE="${IUSE_VIDEO_CARDS}
+       bindist +classic debug +egl +gallium gles +llvm motif +nptl openvg pic selinux shared-dricore +shared-glapi kernel_FreeBSD"
+
+LIBDRM_DEPSTRING=">=x11-libs/libdrm-2.4.24"
+# not a runtime dependency of this package, but dependency of packages which
+# depend on this package, bug #342393
+EXTERNAL_DEPEND="
+       >=x11-proto/dri2proto-2.2
+       >=x11-proto/glproto-1.4.11
+"
+# keep correct libdrm and dri2proto dep
+# keep blocks in rdepend for binpkg
+RDEPEND="${EXTERNAL_DEPEND}
+       !<x11-base/xorg-server-1.7
+       !<=x11-proto/xf86driproto-2.0.3
+       classic? ( app-admin/eselect-mesa )
+       gallium? ( app-admin/eselect-mesa )
+       app-admin/eselect-opengl
+       dev-libs/expat
+       dev-libs/libxml2[python]
+       x11-libs/libICE
+       >=x11-libs/libX11-1.3.99.901
+       x11-libs/libXdamage
+       x11-libs/libXext
+       x11-libs/libXi
+       x11-libs/libXmu
+       x11-libs/libXxf86vm
+       motif? ( x11-libs/openmotif )
+       gallium? (
+               llvm? ( >=sys-devel/llvm-2.9 )
+       )
+       ${LIBDRM_DEPSTRING}[video_cards_nouveau?,video_cards_vmware?]
+"
+for card in ${INTEL_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_intel] )
+       "
+done
+
+for card in ${RADEON_CARDS}; do
+       RDEPEND="${RDEPEND}
+               video_cards_${card}? ( ${LIBDRM_DEPSTRING}[video_cards_radeon] )
+       "
+done
+
+DEPEND="${RDEPEND}
+       =dev-lang/python-2*
+       dev-util/pkgconfig
+       sys-devel/bison
+       sys-devel/flex
+       x11-misc/makedepend
+       x11-proto/inputproto
+       >=x11-proto/xextproto-7.0.99.1
+       x11-proto/xf86driproto
+       x11-proto/xf86vidmodeproto
+"
+
+S="${WORKDIR}/${MY_P}"
+
+# It is slow without texrels, if someone wants slow
+# mesa without texrels +pic use is worth the shot
+QA_EXECSTACK="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+QA_WX_LOAD="usr/lib*/opengl/xorg-x11/lib/libGL.so*"
+
+# Think about: ggi, fbcon, no-X configs
+
+pkg_setup() {
+       # gcc 4.2 has buggy ivopts
+       if [[ $(gcc-version) = "4.2" ]]; then
+               append-flags -fno-ivopts
+       fi
+
+       # recommended by upstream
+       append-flags -ffast-math
+
+       python_set_active_version 2
+       python_pkg_setup
+}
+
+src_unpack() {
+       default
+       [[ $PV = 9999* ]] && git-2_src_unpack
+}
+
+src_prepare() {
+       # apply patches
+       if [[ ${PV} != 9999* && -n ${SRC_PATCHES} ]]; then
+               EPATCH_FORCE="yes" \
+               EPATCH_SOURCE="${WORKDIR}/patches" \
+               EPATCH_SUFFIX="patch" \
+               epatch
+       fi
+       # fix for hardened, bug 240956
+       [[ ${PV} != 9999* ]] && epatch "${FILESDIR}"/glx_ro_text_segm.patch
+
+       # FreeBSD 6.* doesn't have posix_memalign().
+       if [[ ${CHOST} == *-freebsd6.* ]]; then
+               sed -i \
+                       -e "s/-DHAVE_POSIX_MEMALIGN//" \
+                       configure.ac || die
+       fi
+       # Solaris needs some recent POSIX stuff in our case
+       if [[ ${CHOST} == *-solaris* ]] ; then
+               sed -i -e "s/-DSVR4/-D_POSIX_C_SOURCE=200112L/" configure.ac || die
+               sed -i -e 's/uint/unsigned int/g' src/egl/drivers/glx/egl_glx.c || die
+       fi
+
+       # In order for mesa to complete it's build process we need to use a tool
+       # that it compiles. When we cross compile this clearly does not work
+       # so we require mesa to be built on the host system first. -solar
+       if tc-is-cross-compiler; then
+               sed -i -e "s#^GLSL_CL = .*\$#GLSL_CL = glsl_compiler#g" \
+                       "${S}"/src/mesa/shader/slang/library/Makefile || die
+       fi
+
+       base_src_prepare
+
+       eautoreconf
+}
+
+src_configure() {
+       local myconf
+
+       if use classic; then
+       # Configurable DRI drivers
+               driver_enable swrast
+               driver_enable video_cards_intel i810 i915 i965
+               driver_enable video_cards_nouveau nouveau
+               driver_enable video_cards_mach64 mach64
+               driver_enable video_cards_mga mga
+               driver_enable video_cards_r128 r128
+               driver_enable video_cards_radeon radeon r200 r300 r600
+               driver_enable video_cards_savage savage
+               driver_enable video_cards_sis sis
+               driver_enable video_cards_tdfx tdfx
+               driver_enable video_cards_via unichrome
+       fi
+
+       myconf+="
+               $(use_enable !bindist texture-float)
+               $(use_enable gles gles1)
+               $(use_enable gles gles2)
+               $(use_enable egl)
+               $(use_enable openvg)
+       "
+       if use egl; then
+               use shared-glapi || die "egl needs shared-glapi. Please either enable shared-glapi or disable the egl use flag ."
+               myconf+="
+                       --with-egl-platforms=drm,x11
+                       $(use_enable gallium gallium-egl)
+               "
+       fi
+
+       if use !gallium && use !classic; then
+               ewarn "You enabled neither classic nor gallium USE flags. No hardware"
+               ewarn "drivers will be built."
+       fi
+       if use gallium; then
+               myconf+="
+                       --with-state-trackers=glx,dri$(use egl && echo ",egl")$(use openvg && echo ",vega")
+                       $(use_enable llvm gallium-llvm)
+               "
+               gallium_enable swrast
+               gallium_enable video_cards_vmware svga
+               gallium_enable video_cards_nouveau nouveau
+               gallium_enable video_cards_intel i915 i965
+               gallium_enable video_cards_radeon r300 r600
+       fi
+
+       # x86 hardened needs glx-rts, bug 240956
+       if use hardened; then
+               myconf+="
+                       $(use_enable x86 glx-rts)
+               "
+       fi
+
+       # --with-driver=dri|xlib|osmesa || do we need osmesa?
+       econf \
+               --disable-option-checking \
+               --with-driver=dri \
+               --disable-glut \
+               --without-demos \
+               --enable-xcb \
+               $(use_enable debug) \
+               $(use_enable motif glw) \
+               $(use_enable motif) \
+               $(use_enable nptl glx-tls) \
+               $(use_enable !pic asm) \
+               $(use_enable shared-dricore) \
+               $(use_enable shared-glapi) \
+               --with-dri-drivers=${DRI_DRIVERS} \
+               --with-gallium-drivers=${GALLIUM_DRIVERS} \
+               ${myconf}
+}
+
+src_install() {
+       base_src_install
+
+       # Save the glsl-compiler for later use
+       if ! tc-is-cross-compiler; then
+               dobin "${S}"/src/glsl/glsl_compiler || die
+       fi
+       # Remove redundant headers
+       # GLUT thing
+       rm -f "${ED}"/usr/include/GL/glut*.h || die "Removing glut include failed."
+       # Glew includes
+       rm -f "${ED}"/usr/include/GL/{glew,glxew,wglew}.h \
+               || die "Removing glew includes failed."
+
+       # Install config file for eselect mesa
+       insinto /usr/share/mesa
+       newins "${FILESDIR}/eselect-mesa.conf.7.11" eselect-mesa.conf || die
+
+       # Move libGL and others from /usr/lib to /usr/lib/opengl/blah/lib
+       # because user can eselect desired GL provider.
+       ebegin "Moving libGL and friends for dynamic switching"
+               dodir /usr/$(get_libdir)/opengl/${OPENGL_DIR}/{lib,extensions,include}
+               local x
+               for x in "${ED}"/usr/$(get_libdir)/libGL.{la,a,so*}; do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/lib \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+               for x in "${ED}"/usr/include/GL/{gl.h,glx.h,glext.h,glxext.h}; do
+                       if [ -f ${x} -o -L ${x} ]; then
+                               mv -f "${x}" "${ED}"/usr/$(get_libdir)/opengl/${OPENGL_DIR}/include \
+                                       || die "Failed to move ${x}"
+                       fi
+               done
+       eend $?
+
+       if use classic || use gallium; then
+                       ebegin "Moving DRI/Gallium drivers for dynamic switching"
+                       local gallium_drivers=( i915_dri.so i965_dri.so r300_dri.so r600_dri.so swrast_dri.so )
+                       keepdir /usr/$(get_libdir)/dri
+                       dodir /usr/$(get_libdir)/mesa
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f "${S}/$(get_libdir)/gallium/${x}" ]; then
+                                       mv -f "${ED}/usr/$(get_libdir)/dri/${x}" "${ED}/usr/$(get_libdir)/dri/${x/_dri.so/g_dri.so}" \
+                                               || die "Failed to move ${x}"
+                                       insinto "/usr/$(get_libdir)/dri/"
+                                       if [ -f "${S}/$(get_libdir)/${x}" ]; then
+                                               insopts -m0755
+                                               doins "${S}/$(get_libdir)/${x}" || die "failed to install ${x}"
+                                       fi
+                               fi
+                       done
+                       for x in "${ED}"/usr/$(get_libdir)/dri/*.so; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       mv -f "${x}" "${x/dri/mesa}" \
+                                               || die "Failed to move ${x}"
+                               fi
+                       done
+                       pushd "${ED}"/usr/$(get_libdir)/dri || die "pushd failed"
+                       ln -s ../mesa/*.so . || die "Creating symlink failed"
+                       # remove symlinks to drivers known to eselect
+                       for x in ${gallium_drivers[@]}; do
+                               if [ -f ${x} -o -L ${x} ]; then
+                                       rm "${x}" || die "Failed to remove ${x}"
+                               fi
+                       done
+                       popd
+               eend $?
+       fi
+}
+
+pkg_postinst() {
+       # Switch to the xorg implementation.
+       echo
+       eselect opengl set --use-old ${OPENGL_DIR}
+       # Select classic/gallium drivers
+       if use classic || use gallium; then
+               eselect mesa set --auto
+       fi
+
+       # warn about patent encumbered texture-float
+       if use !bindist; then
+               elog "USE=\"bindist\" was not set. Potentially patent encumbered code was"
+               elog "enabled."
+       fi
+}
+
+# $1 - VIDEO_CARDS flag
+# other args - names of DRI drivers to enable
+# TODO: avoid code duplication for a more elegant implementation
+driver_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       DRI_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       DRI_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}
+
+gallium_enable() {
+       case $# in
+               # for enabling unconditionally
+               1)
+                       GALLIUM_DRIVERS+=",$1"
+                       ;;
+               *)
+                       if use $1; then
+                               shift
+                               for i in $@; do
+                                       GALLIUM_DRIVERS+=",${i}"
+                               done
+                       fi
+                       ;;
+       esac
+}